SystemOrganization addCategory: #'Ring-History-Browsers'!

!RGSnapshotNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 16:55'!
borderColorNode

	^Color black! !

!RGSnapshotNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 16:55'!
borderColorNode:  aCollection

	^(aCollection detect:[ :each| each = self ] ifNone:[ nil ])
		ifNil: [ self borderColorNode ]
		ifNotNil:[ Color magenta ]! !

!RGSnapshotNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 16:54'!
colorNode: selectedCommit successor: selectedSuccessor 

	^self = selectedCommit
		ifTrue: [ Color cyan ]
		ifFalse:[ 
			self = selectedSuccessor
				ifTrue: [ Color magenta ]
				ifFalse:[ Color transparent ] ]! !

!RGSnapshotNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/22/2011 17:46'!
nonCommitPackages

	^packages difference: commit packages! !

!RGTSourceDrawing methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:52'!
sourceCodeColor: symbol forText: aBoolean

	symbol == #insert ifTrue: [ 
		^ aBoolean
			  ifTrue: [ RGColor darkestGreen ]
			  ifFalse:[ RGColor addedMethod ] ].
	
	symbol == #remove ifTrue: [ ^ RGColor removedMethod ].
	
	aBoolean ifTrue: [ ^ RGColor black ].
	
	^ RGColor unchanged! !

!RGTSourceDrawing methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:52'!
sourceCodeColorForText: aBoolean

	(self firstVersion wasHistoryAdded: self) ifTrue: [ 
		^ aBoolean 
		      ifTrue: [ RGColor darkestGreen ]
			ifFalse:[ RGColor addedMethod ] ].
	
	(self firstVersion wasHistoryRemoved: self) ifTrue: [ ^ RGColor removedMethod ].
	
	aBoolean ifTrue: [ ^ RGColor black ].
	
	^ RGColor unchanged! !

!RGTSourceDrawing methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:52'!
sourceCodeLightColor

	self wasAdded ifTrue: [ ^ RGColor addedComment ].
	
	self wasRemoved ifTrue: [ ^ RGColor removedComment ].
	
	^ RGColor unchanged! !

!RGTSourceDrawing methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:53'!
sourceCodeLightColor: symbol forText: aBoolean

	symbol == #insert
	ifTrue:[ ^RGColor addedComment ].
	
	symbol == #remove
	ifTrue:[ ^RGColor removedComment ].
	
	^RGColor unchanged! !

!RGTSourceDrawing methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:56'!
viewSourceCodeOn: view
	
	self viewSourceCodeOn: view diffTo: nil! !

!RGTSourceDrawing methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:57'!
viewSourceCodeOn: view diffTo: aRGHistory
	| code nodes fontColor fillColor borderColor borderStyle widthHeader |
	
	aRGHistory notNil
		ifTrue: [ 
			code := [ :line| line value ].
			nodes := self sourceCodeDiffTo: aRGHistory.
			fontColor := [ :line| self sourceCodeColor: line key forText: true ].
			fillColor := [ :line| self sourceCodeLightColor: line key forText: true ].
			borderColor := [ :each| aRGHistory borderColor ].
			borderStyle := [ :each| aRGHistory borderStyle ].
			widthHeader := aRGHistory nodeHeaderSourceCodeOn: view. ]
		ifFalse:[	
			code := [ :each| each sourceCode ].
			nodes := { self }.
			fontColor := [ :each| each sourceCodeColorForText: true ].
			fillColor := [ :each| each sourceCodeLightColor ].
			borderColor := [ :each| each borderColor ].
			borderStyle := [ :each| each borderStyle ].
			widthHeader := self nodeHeaderSourceCodeOn: view ].
	
	view nodeShape
 		width: widthHeader;
		borderColor: borderColor;
		borderStyle: borderStyle;
		borderWidth: 2.
	view node: self forIt:[	
		view nodeShape 
			withoutBorder
			text: code;
			fontColor: fontColor;
			fillColor: fillColor;
			fontSize: 8.
		view nodes: nodes.
		view verticalLineLayout
			verticalGap: 0 ].
		
	view verticalLineLayout
		 verticalGap: -1! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 10:24'!
borderColor

	(self firstVersion wasHistoryAdded: self) ifTrue: [ ^ RGColor addedMethod ].
	(self firstVersion wasHistoryRemoved: self) ifTrue: [ ^ RGColor removedMethod ].
"	self modifiedConditionColor ifTrue: [ ^ RGColor modifiedSourceCode ]."
	
	^ RGColor darkGray! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 10:49'!
borderStyle
	
	^self isExtension
		ifTrue: [ BorderStyle dashed dashColors: {self borderColor . RGColor white } ]
		ifFalse:[ BorderStyle simple ]! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 10:20'!
nodeHeaderSourceCodeOn: view
	| headerShape header1 header2 width |

	headerShape := 
		RGLabelShape mediumFont
			text: [ :each | each ];
			withoutBorder;
			withBackground.
	header1 := (self parentName, "'self scopeLabel, ' method" '   {', self protocol, '}   ', self stamp).
	header2 := 'Snapshot: ', self firstVersion timeStamp asString.
	width := headerShape widthOfText: header1.
	
	view nodeShape 
		borderColor:[ :each| each borderColor ];
		borderStyle:[ :each| each borderStyle ].
	view noInteraction.
	view node: self forIt:[
		view node: header1 using: headerShape.
		headerShape 
			textAlignment: #right;
			width: width.
		view node: header2 using: headerShape.
		view verticalLineLayout verticalGap: 2 ].
	^ width - 2! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/5/2011 14:01'!
viewImplementorsMap
	| nodes implementors view wrapper viewNodes |
	
	nodes := OrderedCollection new.
	implementors := self implementors.
	wrapper := self asHistoryWrapper: self lookupVersion.
	nodes add: wrapper; addAll: implementors.
	view := MOViewRenderer title: 'Implementors of #', self selector.
	view nodeShape 
		text:[ :e| e name ];
		fillColor:[ :e| e colorByStatus ].	
	view interaction 
		popupView: [ :entity :myView | entity viewVersionHistoryOn: myView ] delay: 50;
		highlightWhenOver.
	view interaction on: MOMouseDouble do: [ :ann | 
		ann model isMethod 
			ifTrue: [ ann model viewImplementorsWithHistoryMap ] ].
	viewNodes := view nodes: nodes.
	view edgeFrom: [ wrapper ] toAll: [ implementors ].
	implementors size > 8
		ifTrue: [ view layout: (MOCircleLayout forNodes: viewNodes allButFirst) ]
		ifFalse:[ view treeLayout ].
	^view open! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/5/2011 13:55'!
viewImplementorsWithHistoryMap
	| nodes implementors view wrapper |
	
	nodes := OrderedCollection new.
	wrapper := self asHistoryWrapper: self lookupVersion.
	implementors := self implementors.
	nodes add: wrapper; addAll: implementors.

	view := MOViewRenderer title: 'Implementors Evolution of #', self selector.
	view interaction 
		whenClickingUpdateNode: [ :node|
			view nodeShape 
				withoutBorder;
				text:[ :e| node fullName ].
			view interaction forwarder.
			view node: node ] 
		whenClickingBackUpdateNode:  [:node | 
			node viewVersionHistoryOn: view ]  
		withLayoutUpdate: true. 	
		
	view nodes: nodes forEach:[ :node| 
		node viewVersionHistoryOn: view ].
	view edgeFrom: [ wrapper ] toAll: [ implementors ].
	view treeLayout.
	^ view open! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/5/2011 14:01'!
viewSendersMap
	| nodes senders view wrapper edgeToYourself viewNodes |
	
	edgeToYourself := false.
	wrapper := self asHistoryWrapper: self lookupVersion.
	nodes := OrderedCollection with: wrapper.
	senders := self senders.

	(senders includes: wrapper) 
		ifTrue: [ edgeToYourself := true. 
				senders := senders difference: { wrapper } ].
	nodes addAll: senders.
	edgeToYourself ifTrue: [ nodes add: wrapper ].
	
	view := MOViewRenderer title: 'Senders of #', self fullName.
	view nodeShape 
		text:[ :e| e selector ];
		fillColor:[ :e| e colorByStatus ].
	
	view interaction 
		popupView: [ :entity :myView | entity viewVersionHistoryOn: myView ] delay: 50;
		highlightWhenOver.
	view interaction on: MOMouseDouble do: [ :ann | 
		ann model viewSendersWithHistoryMap ].
		
	viewNodes := view nodes: nodes.
	edgeToYourself
		ifTrue: [ view addEdgeFromNode: viewNodes first toNode: viewNodes last ].
	view edgeFrom: [ wrapper ] toAll: [ senders ].
	senders size > 8
		ifTrue: [ view layout: (MOCircleLayout forNodes: viewNodes allButFirst) ]
		ifFalse:[ view treeLayout ].
	^ view open! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/5/2011 13:53'!
viewSendersWithHistoryMap
	| nodes senders view wrapper |
	
	wrapper := self asHistoryWrapper: self lookupVersion.
	nodes := OrderedCollection with: wrapper.
	senders := self senders.
	
	(senders includes: wrapper) 
		ifTrue: [ senders := senders difference: { wrapper } ].
	nodes addAll: senders.
			
	view := MOViewRenderer title: 'Senders Evolution of #', self fullName.
	view interaction 
		whenClickingUpdateNode: [ :node|
			view nodeShape 
				withoutBorder;
				text:[ :e| node fullName ].
			view interaction forwarder.
			view node: node ] 
		whenClickingBackUpdateNode:  [:node | 
			node viewVersionHistoryOn: view ]  
		withLayoutUpdate: true. 	
		
	view nodes: nodes forEach:[ :node| 
		view interaction forward.
		node viewVersionHistoryOn: view ].
	view edgeFrom: [ wrapper ] toAll: [ senders ].
	view treeLayout.
	^ view open! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/21/2011 15:14'!
viewSourceCodeDetails
	| browser |
	
	browser := GLMTabulator new.
	browser title: self nameWithTime.
	browser 
		row:[ :r| r column: #invocations; column: #accesses; column: #references.];
		row: #sourceCode.
	browser transmit to: #sourceCode; andShow: [:a | 
		a  text
			display: [ :mth| mth sourceCode ];
			forSmalltalk: [ :mth| mth parent ] ].
	browser transmit to: #invocations; andShow: [:a | 
		a title: 'Invocations'.
		a  list
			display: [ :mth| mth invocations sort: self sortByName ];
			format:[ :each| each message ];
			when: [ :mth| mth invocations notEmpty ] ].
	browser transmit to: #accesses; andShow: [:a | 
		a title: 'Accesses'.
		a list				
			display: [ :mth| mth accesses sort: self sortByName ];
			format:[ :each| each labelForView ];
			when: [ :mth| mth accesses notEmpty ] ].
	browser transmit to: #references; andShow: [:a | 
		a title: 'References'.
		a list
			display: [ :mth| mth references sort: self sortByName ];
			format:[ :each| each target name ];
			when: [ :mth| mth references notEmpty ] ].
	^browser openOn: self! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 10:47'!
viewSourceCodeDiffTo: aRGHistory
	| view |
	
	view := MOViewRenderer title: 'Diff to ', self successors first firstVersion timeStamp asString.
	self viewSourceCodeOn: view diffTo: aRGHistory.
	view open! !

!RGMethodHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 00:03'!
viewVersionHistoryOn: view
	| nodes |
	nodes := self withAllPredecessors.

	view nodeShape
		withoutBorder;
		fillColor: [ :e| Color white ].
	view node: self forIt:[ 	
		view nodeShape 
			size: 10;
			fillColor:[ :e| e colorByStatus ].
		view interaction 
			popupText: [ :each| each nameWithTime ];
			popupView: [ :each :popupView | each entity viewSourceCodeOn: popupView ];
			on: MOMouseDouble do: [ :ann | ann model viewSourceCodeDetails ].
		
		view interaction 
			item: [ :each | 
				each successors notEmpty
					ifTrue: [ 'Diff to ', each successors first firstVersion timeStamp asString ]
					ifFalse:[ 'Diff not available' ] ]
			action:[ :each| 
				each successors notEmpty 
					ifTrue: [ (each associationsDiffTo: each successors first) viewAssociationsDiffMap ] ].
		
	"	view interaction forward.
		view interaction 
			registerForEvent: MOElementSelection
			forNodes: [:v | nodes ]
			updateShape: [:shape | ]
			updateLayout: false.
		view interaction 
			registerForEvent: MOElementDeselection
			forNodes: [:v | nodes ]
			updateShape: [:shape | ]
			updateLayout: false."
	
		view nodes: nodes.
		view interaction 
			popupView: [ :from :to :popupView | 
				 from viewSourceCodeOn: popupView diffTo: to
				"(each isKindOf: Association)
					ifTrue: [ each value viewSourceCodeOn: popupView diffTo: each key ]
					ifFalse:[ each entity viewSourceCodeOn: popupView ]" ].
		view edges: nodes
			from: [ :each | each ] 
			toAll: [ :each | each predecessors ].
		view dominanceTreeLayout ]! !

!RGSnapshotDeltaHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 12/2/2011 11:40'!
forcedLayout 

	^ MOForceBasedLayout new! !

!RGSnapshotDeltaHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 14:50'!
resetEdgesOn: view 

	view 
		edges: #() 
		from: #yourself! !

!RGSnapshotDeltaHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 12/2/2011 11:40'!
treeLayout 

	^MODominanceTreeLayout new
		verticalGap: 100; 
		horizontalGap: 10! !

!RGSnapshotDeltaHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 14:46'!
viewDeltasDependenciesMap
	| view |
	view := MOViewRenderer title: 'Deltas Dependencies Map'.
	self viewDeltasDependenciesMap: view.
	^ view open! !

!RGSnapshotDeltaHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 12/3/2011 11:48'!
viewDeltasDependenciesMap: view
	| outgoingDeltas incomingDeltas neededDeltas |
	
	incomingDeltas := Dictionary new.
	outgoingDeltas := Dictionary new.
	deltas do:[ :each| 
		neededDeltas := each traversedOutgoingNeededDeltas.
		neededDeltas notEmpty ifTrue: [ 
			outgoingDeltas at: each put: neededDeltas ].
		neededDeltas := each traversedIncomingNeededDeltas.
		neededDeltas notEmpty ifTrue: [ 
			incomingDeltas at: each put: neededDeltas ] ].

	view interaction
		whenClickingUpdateNode: [ :enode | 
			self viewEdgesOfDelta: enode with: outgoingDeltas with: incomingDeltas on: view ]
		whenClickingBackUpdateNode: [ :enode | 
			self resetEdgesOn: view ] 
		withLayoutUpdate: false.
	view interaction 
		on: MOMouseDouble do: [:el | el element model viewDependenciesMap ].

	view nodeShape 
		height: ((RGNumberLinearNormalizer
						inContext: incomingDeltas
						withCommand: [:entity | 
							((incomingDeltas includesKey: entity) ifTrue: [ (incomingDeltas at: entity) size ] ifFalse:[ 0 ]) ]) initialNumber: 12; maxNumber: 100; scale: 2);		
		borderWidth: ((RGNumberLinearNormalizer
						inContext: outgoingDeltas
						withCommand: [:entity | 
							((outgoingDeltas includesKey: entity) ifTrue: [ (outgoingDeltas at: entity) size ] ifFalse:[ 0 ]) ]) initialNumber: 1; maxNumber: 10);
		fillColor: [ : e| e lightColorByNeededDeltas ];
		borderColor: [ :e| e colorByNeededDeltas ];
		text: [ :e| e minimalName ];
		textAlignment: #center;
		textVerticalPadding: 3;
		textHorizontalPadding: 2.
	view  interaction 
		popupText: [ :each| each name ].
	view nodes: (outgoingDeltas keys union: incomingDeltas keys).
	view
		edges: (outgoingDeltas keys) 
		from:  #yourself
		toAll: [ :each| outgoingDeltas at: each ]
		using: (view shape arrowedLine arrowSize: 4).! !

!RGSnapshotDeltaHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 12/2/2011 11:39'!
viewDeltasDependenciesMapWithLayout: aLayout
	| view |
	view := MOViewRenderer title: 'Deltas Dependencies Map'.
	self viewDeltasDependenciesMap: view.
	view layout: aLayout. 		
	^ view open! !

!RGSnapshotDeltaHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 12/2/2011 01:49'!
viewEdgesOfDelta: node with: outgoingDeltas with: incomingDeltas on: view 

	view interaction 
		popupText: [ :from :to| from name, ' => ', to name ].
	view
		edges: { node }
		from: #yourself
		toAll: [ :each| outgoingDeltas at: each ifAbsent:[ #() ] ]
		using: (view shape arrowedLine 
				arrowSize: 4;
				color: RGColor red4).

"	view interaction 
		popupText: [ :from :to| from name, ' => ', to name ].
	view
		edges: (myDependentDeltas at: node ifAbsent:[ #() ])
		from: #yourself
		to: [ :each| node ]
		using: (view shape arrowedDashedLine
				arrowSize: 4;
				color: RGColor red3)"! !

!RGMethodAssociationsDiff methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 13:55'!
viewAssociationsDiffMap
	| nodes view subNodes |
	
	view := MOViewRenderer title: source fullName, ' (diff from ', source lookupVersion timeStamp asString, ' to ', target lookupVersion timeStamp asString, ')'.
	nodes := {#invocations . #accesses . #references}.			
	
	view nodeShape withoutBorder.
	view nodes: nodes forEach:[ :each|
		| added removed |
		each = #invocations ifTrue: [
			added := self addedInvocations.
			removed := self removedInvocations ].
		each = #accesses ifTrue: [
			added := self addedAccesses.
			removed := self removedAccesses ].
		each = #references ifTrue: [
			added := self addedReferences.
			removed := self removedReferences ].
		view nodeShape 
			text: [ :e| each ].
		(added isEmpty and:[ removed isEmpty ])
			ifFalse:[ view node: target ].
		view nodeShape
			text: [ :e| e labelForView ];
			height: 15;
			borderColor: [ :e | Color green ].
		view nodes: added.
		view nodeShape
			text: [ :e| e labelForView ];
			height: 15;
			borderColor: [ :e | Color red ].
		view nodes: removed.
		view edgeFrom: target toAll: added.
		view edgeFrom: target toAll: removed.
		view treeLayout ].
	view verticalLineLayout.
	^ view open! !

!RGMethodAssociationsDiff methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/5/2011 16:07'!
viewDiffMap
	| nodes view subNodes |
	
	view := MOViewRenderer title: source fullName, ' (diff from ', source lookupVersion timeStamp asString, ' to ', target lookupVersion timeStamp asString, ')'.
	nodes := {#invocations . #accesses . #references}.			
	
	view nodeShape withoutBorder.
	view nodes: nodes forEach:[ :each|
		| added removed |
		each = #invocations ifTrue: [
			added := self addedInvocations.
			removed := self removedInvocations ].
		each = #accesses ifTrue: [
			added := self addedAccesses.
			removed := self removedAccesses ].
		each = #references ifTrue: [
			added := self addedReferences.
			removed := self removedReferences ].
		view nodeShape 
			text: [ :e| each ].
		(added isEmpty and:[ removed isEmpty ])
			ifFalse:[ view node: target ].
		view nodeShape
			text: [ :e| e labelForView ];
			height: 15;
			borderColor: [ :e | Color green ].
		view nodes: added.
		view nodeShape
			text: [ :e| e labelForView ];
			height: 15;
			borderColor: [ :e | Color red ].
		view nodes: removed.
		view edgeFrom: target toAll: added.
		view edgeFrom: target toAll: removed.
		view treeLayout ].
	view verticalLineLayout.
	^ view open! !

!RGSuperInheritanceHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 12/1/2011 15:17'!
lightColorByStatus

	self wasReintroduced ifTrue: [ ^Color lightYellow ].
	self wasAdded ifTrue: [ ^Color lightGreen ].
	self wasRemoved ifTrue: [ ^Color lightRed ].
	self wasMerged ifTrue: [ ^Color lightOrange ].
	self wasModified ifTrue: [ ^Color lightBlue ].
	^Color transparent ! !

!RGPackageHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 14:25'!
summary

	self isExternal ifTrue: [ ^ '' ].
	^ String streamContents: [:s |
		s
			nextPutAll: 'Version: '; 
			nextPutAll: self versionName asString; cr; 
			nextPutAll: 'Author: '; 
			nextPutAll: self author asString; cr; 
			nextPutAll: 'Timestamp: ';
			nextPutAll: self timeStamp asString; cr; 
			nextPutAll: 'Ancestors: ';
			nextPutAll: self predecessorVersions; cr; 
			nextPutAll: 'Repository: '; 
			nextPutAll: self repositoryLocation asString; cr; cr;
			nextPutAll: self commitMessage asString ]! !

!RGPackageHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 9/21/2011 15:36'!
visibleClasses
	"Retrieves classes that can be drawn and presented in browsers"

	^(self definedClasses, self removedClasses, self movedClasses)
		select:[ :each | each canBeVisualized ]! !

!RGTraitHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 12/1/2011 15:35'!
modifiedCondition

	^ self wasModifiedConsideringMetaclassAndMethods ! !

!RGClassHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 12/1/2011 15:35'!
modifiedCondition

	^ self wasModifiedConsideringMetaclassAndMethods ! !

!RGClassHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 10:14'!
nodeHeaderSourceCodeOn: view
	| headerShape header1 header2 width |

	headerShape := 
		RGLabelShape mediumFont
			text: [ :each | each ];
			withoutBorder;
			withBackground.
	self hasStamp 
		ifTrue: [ header1 := self stamp, '		Snapshot: ', self firstVersion stamp ]
		ifFalse:[ header1 :=  'Snapshot: ', self firstVersion timeStamp asString ].
	width := headerShape widthOfText: header1.
	
	view nodeShape 
		borderColor:[ :each| each borderColor ];
		borderStyle:[ :each| each borderStyle ].
	view noInteraction.
	view node: self forIt:[
		view node: header1 using: headerShape.
"		headerShape 
			textAlignment: #right;
			width: width.
		view node: header2 using: headerShape."
		view verticalLineLayout verticalGap: 2 ].
	^ width - 2! !

!RGMissingPackageNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/8/2011 17:10'!
borderColorNode

	^self colorNode! !

!RGMissingPackageNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 14:32'!
colorNode

	^Color red! !

!RGPackageGraph methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 11:15'!
uniqueSuccessorsPerPackage: packageName
	| uniqueSuccessors |

	uniqueSuccessors := Set new.
	(roots at: packageName)
		do:[ :root|  uniqueSuccessors addAll: root allSuccessors ].
		
	^uniqueSuccessors! !

!RGPackageGraph methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/22/2011 16:43'!
viewPackageGraph: view selectedPackages: selectedPackages
	| nodes value withAllSuccessors uniqueSuccessors |
	
	selectedPackages isEmptyOrNil
		ifTrue: [ nodes := self packageNames sort: [:e1 :e2 | e1 name <= e2 name] ]
		ifFalse:[ nodes := selectedPackages ].
	nodes do:[ :key|
		value := roots at: key.
		withAllSuccessors := self uniqueSuccessorsPerPackage: key.
		withAllSuccessors addAll: value.
		view nodeShape 
			withoutBorder;
			text: [ :each | each ].
		view node: key.
		view nodeShape withoutBorder.
		view noInteraction.
		view node: nil forIt:[
			view nodeShape
				borderColor:[ :each| each borderColorNode ];
				fillColor:[ :each| each colorNode ].
			view nodes: withAllSuccessors.
			view edges: withAllSuccessors from: [ :n| n ] toAll:[ :n | n successors ].
			view horizontalDominanceTreeLayout
			].
		view verticalLineLayout.
		 ]. ! !

!RGReferenceHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/5/2011 15:40'!
labelForView

	^ self target name ! !

!RGModifiedChange methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/28/2011 15:47'!
color

	^  RGColor blue3! !

!RGModifiedChange methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:43'!
viewSourceCodeOn: view

	obsoleteEntity viewSourceCodeOn: view diffTo: entity ! !

!RGRepositorySnapshot methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/15/2011 15:47'!
browser

	RGSnapshotBrowser open: self! !

!RGRepositorySnapshot methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 9/23/2011 09:17'!
viewComparativeClassesHistoryOn: view selectedEntities: packagesOrClasses
	| predecCollection classIDs classCollection packageIDs forEdges sortedClassNames classes |
	
	predecCollection := self withAllPredecessors.
	packageIDs := OrderedCollection new.
	classIDs := Dictionary new.
	classes := Dictionary new.
	
	packagesOrClasses do:[ :each|
		(each isClass or:[ each isTrait ]) ifTrue: [ 
			classIDs at: each name put: each historyID ].
		each isPackage ifTrue: [ 
			each lookupVersion: self. 
			packageIDs add: each historyID.
			classIDs := classIDs,  each definedClassIDs, each removedDefinedClassIDs, each movedDefinedClassIDs ] ].
	sortedClassNames := classIDs keys sort: self sortByName.
	classIDs keysAndValuesDo:[ :k :v | | c |
		c := self historyWrapperAtIDEvenIfRemoved: v.
		c canBeVisualized 
			ifTrue: [ classes at: k put: c withAllUnwrappedPredecessors ] ]. 
	
	view nodeShape withoutBorder.
	view noInteraction.
	view node: nil forIt: [
	predecCollection do:[ :pred|
		view nodeShape
			borderColor: [ :each| Color lightGray ]; 
			borderStyle: [ :each| BorderStyle dashed ].
		view node: pred forIt:[
			| clsNode hasBorder |
			sortedClassNames do:[ :className|
				view nodeShape size: 10.				
				hasBorder := false.
				clsNode := nil.
				classes at: className ifPresent:[ :col| clsNode := col detect:[ :p| p firstVersion = pred ] ifNone:[ nil ] ].		
				clsNode notNil ifTrue: [
					clsNode := pred thisHistoryEvenIfRemoved: clsNode.
					packageIDs isEmpty ifFalse:[
						(packageIDs includes: clsNode package historyID) 
							ifFalse:[ clsNode := nil  ] ] ].
				clsNode notNil
					ifTrue: [ hasBorder := true.
						      view nodeShape fillColor:[ :e| e colorByStatus ] ].
				hasBorder 
					ifFalse:[ 
						view nodeShape withoutBorder.
						view noInteraction ].
				view node: clsNode ].
			view horizontalLineLayout ].
		
		view verticalLineLayout  ] ].

	classes do:[ :collection|
		 view edges: collection
			from: [ :each | each ] 
			toAll: [ :each | each unwrappedSuccessors ] ].
	view horizontalDominanceTreeLayout.! !

!RGRepositorySnapshot methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 9/21/2011 15:28'!
visibleClasses 
	"Retrieves classes that can be drawn and presented in browsers"
	| classes |
	
	classes := self resolveCollectionWithRemovals: (self classIDs values).
	^ classes select:[ :each| each canBeVisualized ]! !

!RGChange methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/28/2011 15:47'!
color

	^ RGColor unchanged ! !

!RGChange methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 16:11'!
icon

	self isAddition ifTrue: [ ^ RGMenuIcons addIcon ].
	self isRemoval ifTrue: [ ^ RGMenuIcons deleteIcon ].
	self isModification ifTrue: [ ^ RGMenuIcons editIcon ].
	^RGMenuIcons blankIcon ! !

!RGTHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 12/1/2011 15:35'!
colorByStatus

	self wasReintroduced ifTrue: [ ^Color yellow ].
	self wasAdded ifTrue: [ ^Color green ].
	self wasRemoved ifTrue: [ ^Color red ].
	self wasMerged ifTrue: [ ^Color orange ].
	self wasModified ifTrue: [ ^Color blue ].
	^Color transparent! !

!RGTHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 9/16/2011 08:08'!
iconByStatus

	self wasAdded ifTrue:[ ^RGMenuIcons addIcon ].
	self wasRemoved ifTrue:[ ^RGMenuIcons deleteIcon ].
	self wasModified ifTrue:[ ^RGMenuIcons editIcon ].
	
	^MenuIcons blankIcon! !

!RGTHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 12/1/2011 15:35'!
lightColorByStatus

	self wasReintroduced ifTrue: [ ^Color lightYellow ].
	self wasAdded ifTrue: [ ^Color lightGreen ].
	self wasRemoved ifTrue: [ ^Color lightRed ].
	self wasMerged ifTrue: [ ^Color lightOrange ].
	self modifiedCondition ifTrue: [ ^Color lightBlue ].
	^Color transparent! !

!RGTHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 12/1/2011 15:35'!
modifiedCondition

	^ self wasModified! !

!RGTHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 9/16/2011 08:26'!
nameWithTime

	^self fullName, ' (', self firstVersion timeStamp asString, ')'! !

!RGTHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/6/2011 12:52'!
viewVersionHistory
	| view |
	view := MOViewRenderer title: 'History of #', self nameWithTime.
	self viewVersionHistoryOn: view.
	^ view open! !

!RGTHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/5/2011 14:07'!
viewVersionHistoryOn: view
	| nodes |
	nodes := self withAllPredecessors.

	view nodeShape
		withoutBorder;
		fillColor: [ :e| Color white ].
	view node: self forIt:[ 	
		view nodeShape 
			size: 10;
			fillColor:[ :e| e colorByStatus ].
		view interaction popupText: [ :each| each nameWithTime ].
	"	view interaction forward.
		view interaction 
			registerForEvent: MOElementSelection
			forNodes: [:v | nodes ]
			updateShape: [:shape | ]
			updateLayout: false.
		view interaction 
			registerForEvent: MOElementDeselection
			forNodes: [:v | nodes ]
			updateShape: [:shape | ]
			updateLayout: false."
	
		view nodes: nodes.
		view edges: nodes
			from: [ :each | each ] 
			toAll: [ :each | each predecessors ].
		view dominanceTreeLayout ]! !

!RGAccessHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/8/2011 12:09'!
labelForView

	^ self keyName! !

!RGPackageNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/13/2011 21:11'!
borderColorNode

	^self isExternal
		ifTrue: [ Color purple ]
		ifFalse:[ Color black ]! !

!RGPackageNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/13/2011 21:11'!
colorNode

	^self isExternal
		ifTrue: [ Color purple ]
		ifFalse:[ Color white ]! !

!RGCommitGraph methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/22/2011 17:01'!
viewCommitGraph: view selectedCommit: selectedCommit selectedSuccessor: selectedSuccessor
	
	view nodeShape
		borderColor: [ :each| each borderColorNode: (selectedCommit ifNil:[ #() ] ifNotNil:[ :s| s successors ]) ];
		fillColor:[ :each| each colorNode: selectedCommit successor: selectedSuccessor ].
	view nodes: self commitNodes forEach:[ :commit|
		view nodeShape
			borderColor:[ :each| each borderColorNode ];
			fillColor:[ :each| each colorNode ]. 
		view nodes: commit packages.
		view flowLayout maxWidth: 40 ].
	view edges: self commitNodes from: [ :n| n ] toAll:[ :n | n successors ].
	view horizontalDominanceTreeLayout 
		verticalGap: 8! !

!RGTSourceDiff methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:52'!
sourceCodeColor: symbol forText: aBoolean

	symbol == #insert ifTrue: [ 
		^ aBoolean
			  ifTrue: [ RGColor darkestGreen ]
			  ifFalse:[ RGColor addedMethod ] ].
	
	symbol == #remove ifTrue: [ ^ RGColor removedMethod ].
	
	aBoolean ifTrue: [ ^ RGColor black ].
	
	^ RGColor unchanged! !

!RGTSourceDiff methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:52'!
sourceCodeColorForText: aBoolean

	(self firstVersion wasHistoryAdded: self) ifTrue: [ 
		^ aBoolean 
		      ifTrue: [ RGColor darkestGreen ]
			ifFalse:[ RGColor addedMethod ] ].
	
	(self firstVersion wasHistoryRemoved: self) ifTrue: [ ^ RGColor removedMethod ].
	
	aBoolean ifTrue: [ ^ RGColor black ].
	
	^ RGColor unchanged! !

!RGTSourceDiff methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:52'!
sourceCodeLightColor

	self wasAdded ifTrue: [ ^ RGColor addedComment ].
	
	self wasRemoved ifTrue: [ ^ RGColor removedComment ].
	
	^ RGColor unchanged! !

!RGTSourceDiff methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:53'!
sourceCodeLightColor: symbol forText: aBoolean

	symbol == #insert
	ifTrue:[ ^RGColor addedComment ].
	
	symbol == #remove
	ifTrue:[ ^RGColor removedComment ].
	
	^RGColor unchanged! !

!RGTSourceDiff methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:56'!
viewSourceCodeOn: view
	
	self viewSourceCodeOn: view diffTo: nil! !

!RGTSourceDiff methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:57'!
viewSourceCodeOn: view diffTo: aRGHistory
	| code nodes fontColor fillColor borderColor borderStyle widthHeader |
	
	aRGHistory notNil
		ifTrue: [ 
			code := [ :line| line value ].
			nodes := self sourceCodeDiffTo: aRGHistory.
			fontColor := [ :line| self sourceCodeColor: line key forText: true ].
			fillColor := [ :line| self sourceCodeLightColor: line key forText: true ].
			borderColor := [ :each| aRGHistory borderColor ].
			borderStyle := [ :each| aRGHistory borderStyle ].
			widthHeader := aRGHistory nodeHeaderSourceCodeOn: view. ]
		ifFalse:[	
			code := [ :each| each sourceCode ].
			nodes := { self }.
			fontColor := [ :each| each sourceCodeColorForText: true ].
			fillColor := [ :each| each sourceCodeLightColor ].
			borderColor := [ :each| each borderColor ].
			borderStyle := [ :each| each borderStyle ].
			widthHeader := self nodeHeaderSourceCodeOn: view ].
	
	view nodeShape
 		width: widthHeader;
		borderColor: borderColor;
		borderStyle: borderStyle;
		borderWidth: 2.
	view node: self forIt:[	
		view nodeShape 
			withoutBorder
			text: code;
			fontColor: fontColor;
			fillColor: fillColor;
			fontSize: 8.
		view nodes: nodes.
		view verticalLineLayout
			verticalGap: 0 ].
		
	view verticalLineLayout
		 verticalGap: -1! !

!RGTBehaviorHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:54'!
borderColor

	(self firstVersion wasHistoryAdded: self) ifTrue: [ ^ RGColor addedMethod ].
	(self firstVersion wasHistoryRemoved: self) ifTrue: [ ^ RGColor removedMethod ].
"	self modifiedConditionColor ifTrue: [ ^ RGColor modifiedSourceCode ]."
	
	^ RGColor darkGray! !

!RGTBehaviorHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:58'!
borderStyle
	
	^ BorderStyle simple! !

!RGTBehaviorHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 9/9/2011 13:16'!
canBeVisualized
	"The receiver can be visualized if it a non-external class or if its a extendedClass (which it this case doesn mater if is external)"

	^ self isExternal not or:[ self isExtendedClass ]! !

!RGTBehaviorHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/28/2011 23:19'!
nameWithExternalLabel

	^ (self name, 
		(self isExternal 
			ifTrue: [ ' [external class]' ]
			ifFalse:[ '' ] ) ) asSymbol! !

!RGTBehaviorHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 10:19'!
nodeHeaderSourceCodeOn: view
	| headerShape header1 header2 width |

	header1 := ''.
	headerShape := 
		RGLabelShape mediumFont
			text: [ :each | each ];
			withoutBorder;
			withBackground.
	self hasStamp 
		ifTrue: [ header1 := self stamp, '	    ' ].
	header1 :=  'Snapshot: ', self firstVersion timeStamp.
	width := headerShape widthOfText: header1.
	
	view nodeShape 
		borderColor:[ :each| each borderColor ];
		borderStyle:[ :each| each borderStyle ].
	view noInteraction.
	view node: self forIt:[
		view node: header1 using: headerShape.
"		headerShape 
			textAlignment: #right;
			width: width.
		view node: header2 using: headerShape."
		view verticalLineLayout verticalGap: 2 ].
	^ width - 2! !

!RGTBehaviorHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:58'!
sourceCode

	^ self definitionSource ! !

!RGInvocationHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/21/2011 15:13'!
labelForView

	^ self senderName ! !

!RGSnapshotDelta methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 12/1/2011 23:54'!
colorByNeededDeltas

	self hasNoNeededDeltas 
		ifTrue: [ ^ RGColor red2 ].
	self hasOnlyIncomingNeededDeltas 
		ifTrue: [ ^ RGColor green3 ].
	self hasOnlyOutgoingNeededDeltas 
		ifTrue: [ ^ RGColor darkGray ].
	self hasNeededDeltas 
		ifTrue: [ ^ RGColor lightBrown ].
	^ RGColor transparent ! !

!RGSnapshotDelta methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 12/1/2011 23:49'!
lightColorByNeededDeltas

	self hasNoNeededDeltas 
		ifTrue: [ ^ RGColor lightPink ].
	self hasOnlyIncomingNeededDeltas 
		ifTrue: [ ^ RGColor lightGreen ].
	self hasOnlyOutgoingNeededDeltas 
		ifTrue: [ ^ RGColor veryLightGray ].
	self hasNeededDeltas 
		ifTrue: [ ^ RGColor lightOrange ].
	^ RGColor transparent ! !

!RGSnapshotDelta methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/28/2011 21:31'!
resetEdgesOn: view 

	view 
		edges: #() 
		from: #yourself! !

!RGSnapshotDelta methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/28/2011 21:32'!
viewDependenciesMap
	| view |
	view := MOViewRenderer title: 'Dependencies Map of Delta: ', self name.
	self viewDependenciesMap: view.
	^ view open! !

!RGSnapshotDelta methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 12/1/2011 21:49'!
viewDependenciesMap: view
	|  changeDepends neededDeltas fuzzyDeltas nodesForEdges dependentDeltas potentialDeltas |
	
	changeDepends := self dependentChanges collect:[ :each| self changeDependencyOf: each ].
	changeDepends := changeDepends reject:[ :each| each hasDependentDeltas not ].
	nodesForEdges := (OrderedCollection new) addAll: changeDepends.
	neededDeltas := self outgoingNeededDeltasMap.
	potentialDeltas := self outgoingPotentialDeltasMap.
	fuzzyDeltas := self outgoingFuzzyDeltasMap.
	dependentDeltas := (OrderedCollection new) addAll: neededDeltas keys; addAll: fuzzyDeltas keys; yourself.
		
	view nodeShape.
	view node: self forIt:[ 				
		view interaction
			whenClickingUpdateNode: [ :enode | 
				self viewEdgesOfChangeDependency: enode on: view  ]
			whenClickingBackUpdateNode: [ :enode | 
				self resetEdgesOn: view ] 
			withLayoutUpdate: false.
		view nodeShape 
			width: ((MONumberLinearNormalizer
							inContext: changeDepends
							withCommand: [:e | 5 + (e neededDeltasMap size * 3) ]) scale: 40);			
			height: ((MONumberLinearNormalizer
							inContext: changeDepends
							withCommand: [:e | 5 + (e potentialDeltasMap size * 3) ]) scale: 40);		
			fillColor:[ :e| e change color ].
		view interaction 
			popupText: [ :each| each change fullName ].
		"	popupView: [ :each :popupView | 
				 each change viewSourceCodeOn: popupView ]."
		view nodes: changeDepends.
		view verticalLineLayout verticalGap: 20  ].
	
	view nodeShape.
	view noInteraction.
	view node: self forIt:[ 		
		view interaction
			whenClickingUpdateNode: [ :enode | 
				self viewEdgesOfOutgoingFuzzyDelta: enode in: fuzzyDeltas on: view.
				self viewEdgesOfOutgoingNeededDelta: enode in: neededDeltas on: view ]
			whenClickingBackUpdateNode: [ :enode | 
				self resetEdgesOn: view ]
			withLayoutUpdate: false.
		view shape: MOTriangleShape new.
		view nodeShape 
			size: ((MONumberLinearNormalizer
							inContext: neededDeltas keys
							withCommand: [:e | 10 + (neededDeltas at: e) size * 4 ]) scale: 40);		
			fillColor:[ :e| RGColor purple ].
		view interaction popupText: [ :each| each name ].	
		view nodes: neededDeltas keys.

		view interaction
			whenClickingUpdateNode: [ :enode | 
				self viewEdgesOfOutgoingFuzzyDelta: enode in: fuzzyDeltas on: view.
			 	self viewEdgesOfOutgoingNeededDelta: enode in: neededDeltas on: view ]
			whenClickingBackUpdateNode: [ :enode | 
				self resetEdgesOn: view ]
			withLayoutUpdate: false.	
		view shape: MOTriangleShape new.
		view nodeShape 
			size: ((MONumberLinearNormalizer
							inContext: potentialDeltas keys
							withCommand: [:e | 10 + (potentialDeltas at: e) size * 4 ]) scale: 40);		
			fillColor:[ :e| RGColor orange ].
		view interaction popupText: [ :each| each name ].	
		view nodes: potentialDeltas keys.
		
		view edges: dependentDeltas 
			from: [ :each| each]
			to: [ :each| each closePredecessor: dependentDeltas ].
		view treeLayout verticalGap: 30
		"view horizontalLineLayout horizontalGap: 30"  ].
		
	view horizontalLineLayout horizontalGap: 100; alignCenter. ! !

!RGSnapshotDelta methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 12/1/2011 21:49'!
viewEdgesOfChangeDependency: node on: view 
	| deps |

	deps := node fuzzyDeltasMap values collect:[ :each| each size ].
	node fuzzyDeltasMap keysAndValuesDo: [ :key :value |
		view 
			edges: { node } 
			from: #yourself 
			to: [ key ] 
			using: (view shape line 
					color: RGColor orange;
					width: (value size)
						"((MONumberLinearNormalizer
							inContext: deps
							withCommand: [:e | value size ]) scale: 5)") ].
	deps := node neededDeltasMap values collect:[ :each| each size ].					
	node neededDeltasMap keysAndValuesDo: [ :key :value |
		view 
			edges: { node } 
			from: #yourself 
			to: [ key ] 
			using: (view shape line 
					color: RGColor purple;
					width: (value size)
						"((MONumberLinearNormalizer
							inContext: deps
							withCommand: [:e | value size ]) scale: 5)") ].
	view dominanceTreeLayout  ! !

!RGSnapshotDelta methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 12/1/2011 21:47'!
viewEdgesOfOutgoingFuzzyDelta: node in: collection on: view 
	| deps depsSize |
	
	(collection includesKey: node) ifFalse:[ ^self ].
	deps := Dictionary new.
	((collection at: node) collect:[ :each| each changeDependency ]) asSet
		do:[ :each| deps at: each put: (each fuzzyDeltasMap at: node) size ].
	deps keysAndValuesDo: [ :key :value|
		view 
			edges: { node } 
			from: #yourself 
			to: [ key ] 
			using: (view shape line 
					color: RGColor orange;
					width: [ :e| value ]) ].
	view dominanceTreeLayout  ! !

!RGSnapshotDelta methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 12/1/2011 21:42'!
viewEdgesOfOutgoingNeededDelta: node in: collection on: view 
	| deps depsSize |
	
	(collection includesKey: node) ifFalse:[ ^self ].
	deps := Dictionary new.
	((collection at: node) collect:[ :each| each changeDependency ]) asSet
		do:[ :each| deps at: each put: (each neededDeltasMap at: node) size ].
	deps keysAndValuesDo: [ :key :value|
		view 
			edges: { node } 
			from: #yourself 
			to: [ key ] 
			using: (view shape line 
					color: RGColor purple;
					width: [ :e| value ]) ].
	view dominanceTreeLayout  ! !

!RGSnapshotDelta methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 12/1/2011 21:43'!
viewEdgesOfOutgoingPotentialDelta: node in: collection on: view 
	| deps depsSize |
	
	deps := Dictionary new.
	((collection at: node) collect:[ :each| each changeDependency ]) asSet
		do:[ :each| deps at: each put: (each potentialDeltasMap at: node) size ].
	deps keysAndValuesDo: [ :key :value|
		view 
			edges: { node } 
			from: #yourself 
			to: [ key ] 
			using: (view shape line 
					color: RGColor orange;
					width: [ :e| value ]) ].
	view dominanceTreeLayout  ! !

!RGSnapshotDelta methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/15/2011 15:55'!
viewVersionHistory
	| view |
	view := MOViewRenderer title: 'History of #', self name.
	self viewVersionHistoryOn: view.
	^ view open! !

!RGSnapshotDelta methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/16/2011 15:55'!
viewVersionHistoryOn: view
	| nodes |
	nodes := self withAllPredecessors.

	view nodeShape
		withoutBorder;
		fillColor: [ :e| Color white ].
	view node: self forIt:[ 	
		view nodeShape 
			size: 15;
			fillColor:[ :e| Color white ].
		view interaction popupText: [ :each| each name ].	
		view nodes: nodes.
		view edges: nodes
			from: [ :each | each ] 
			toAll: [ :each | each predecessors ].
		view treeLayout  ]! !

!RGCommitNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 11:36'!
borderColorNode

	^Color black! !

!RGCommitNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 14:31'!
borderColorNode:  aCollection

	^(aCollection detect:[ :each| each = self ] ifNone:[ nil ])
		ifNil: [ self borderColorNode ]
		ifNotNil:[ Color magenta ]! !

!RGCommitNode methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/9/2011 14:16'!
colorNode: selectedCommit successor: selectedSuccessor 

	^self = selectedCommit
		ifTrue: [ Color cyan ]
		ifFalse:[ 
			self = selectedSuccessor
				ifTrue: [ Color magenta ]
				ifFalse:[ Color transparent ] ]! !

!RGRemovedHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 10:41'!
borderColor

	(self firstVersion wasHistoryAdded: self) ifTrue: [ ^ RGColor addedMethod ].
	(self firstVersion wasHistoryRemoved: self) ifTrue: [ ^ RGColor removedMethod ].
"	self modifiedConditionColor ifTrue: [ ^ RGColor modifiedSourceCode ]."
	
	^ RGColor darkGray! !

!RGRemovedHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 10:49'!
borderStyle
	
	^self isExtension
		ifTrue: [ BorderStyle dashed dashColors: {self borderColor . RGColor white } ]
		ifFalse:[ BorderStyle simple ]! !

!RGRemovedHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 9/8/2011 18:45'!
canBeVisualized

	^ true! !

!RGRemovedHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 10:44'!
nodeHeaderSourceCodeOn: view
	| headerShape header1 header2 width |

	headerShape := 
		RGLabelShape mediumFont
			text: [ :each | each ];
			withoutBorder;
			withBackground.
	header1 := (self scopeLabel, ' method   {', self protocol, '}   ', self stamp).
	header2 := self firstVersion timeStamp.
	width := headerShape widthOfText: header1.
	
	view nodeShape 
		borderColor:[ :each| each borderColor ];
		borderStyle:[ :each| each borderStyle ].
	view noInteraction.
	view node: self forIt:[
		view node: header1 using: headerShape.
		headerShape 
			textAlignment: #right;
			width: width.
		view node: header2 using: headerShape.
		view verticalLineLayout verticalGap: 2 ].
	^ width - 2! !

!RGRemovedHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/10/2011 10:47'!
viewSourceCodeDiffTo: aRGHistory
	| view |
	
	view := MOViewRenderer title: 'Diff to ', self successors first firstVersion timeStamp asString.
	self viewSourceCodeOn: view diffTo: aRGHistory.
	view open! !

!RGRemovedHistory methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/8/2011 10:48'!
viewSourceCodeOn: view
	
	self nodeHeaderSourceCodeOn: view! !

!RGRemovedChange methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/28/2011 23:13'!
color

	^ RGColor red4! !

!RGRemovedChange methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:46'!
viewSourceCodeOn: view

	entity viewSourceCodeOn: view diffTo: nil ! !

Object subclass: #RGAbstractBrowser
	instanceVariableNames: 'browser model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGAbstractBrowser classSide methodsFor: 'opening' stamp: 'VeronicaUquillas 8/3/2011 16:29'!
open

	^self new open! !

!RGAbstractBrowser classSide methodsFor: 'opening' stamp: 'VeronicaUquillas 8/4/2011 15:17'!
open: model

	^self new 
		model: model;
		open! !

!RGAbstractBrowser methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/12/2011 11:18'!
browser

	^ browser ifNil:[ self buildBrowser. browser]! !

!RGAbstractBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 7/12/2011 11:42'!
buildBrowser

	browser := GLMTabulator new.
	browser title: self titleBrowser.
	self layout! !

!RGAbstractBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 8/4/2011 14:58'!
defaultActions: anObject

	^OrderedCollection new
		add: (self inspectAction: anObject);
		yourself! !

!RGAbstractBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 11/23/2011 22:22'!
initialSelection ! !

!RGAbstractBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 8/4/2011 14:57'!
inspectAction: anObject

	^GLMGenericAction new 
		title: 'Inspect'; 
		action: [ anObject selection inspect ]; 
		yourself! !

!RGAbstractBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 7/12/2011 11:19'!
layout

	self subclassResponsibility ! !

!RGAbstractBrowser methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/12/2011 11:20'!
model

	^model! !

!RGAbstractBrowser methodsFor: 'accessing' stamp: 'VeronicaUquillas 7/12/2011 11:20'!
model: anObject

	model := anObject ! !

!RGAbstractBrowser methodsFor: 'opening' stamp: 'VeronicaUquillas 11/23/2011 22:22'!
open
	
	self browser openOn: self model.
	"with: (TCMorphicRenderer new
					extent: self extent)"					
	self initialSelection! !

!RGAbstractBrowser methodsFor: 'sorting' stamp: 'VeronicaUquillas 11/23/2011 22:39'!
sortBlockByFullName

	^ [:e1 :e2 | e1 fullName <= e2 fullName ]! !

!RGAbstractBrowser methodsFor: 'sorting' stamp: 'VeronicaUquillas 11/23/2011 22:41'!
sortBlockByName

	^ [:e1 :e2 | e1 name <= e2 name]! !

!RGAbstractBrowser methodsFor: 'sorting' stamp: 'VeronicaUquillas 11/23/2011 22:39'!
sortByFullName: aCollection

	^ aCollection sort: self sortBlockByFullName! !

!RGAbstractBrowser methodsFor: 'sorting' stamp: 'VeronicaUquillas 11/23/2011 22:41'!
sortByName: aCollection

	^ aCollection sort: self sortBlockByName! !

!RGAbstractBrowser methodsFor: 'sorting' stamp: 'VeronicaUquillas 8/22/2011 16:23'!
sortByTimestamp: aCollection

	^ aCollection sort: [:e1 :e2 | e1 timeStamp <= e2 timeStamp ]! !

!RGAbstractBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 7/12/2011 11:19'!
titleBrowser

	self subclassResponsibility ! !

RGAbstractBrowser subclass: #RGCommitGraphBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGCommitGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/9/2011 13:31'!
buildBrowser

	super buildBrowser.
	self onCommits.
	self onPackages.
	self onSuccessors.
	self onCommitGraph! !

!RGCommitGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/22/2011 16:57'!
layout

	browser
		column: [:c | c row: #commits span: 4; row: #packages span: 2; row: #successors ]; 
		column: #commitGraph span: 4.! !

!RGCommitGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/9/2011 14:41'!
onCommitGraph

	browser
		showOn: #commitGraph;
		from: #commits;
		from: #successors;
		using: [
			browser mondrian 
				allowNil;
				painting: [ :view :commit :successor |
					self model viewCommitGraph: view selectedCommit: commit selectedSuccessor: successor]
		].
	
	"Need initial display"
	browser transmit to: #commitGraph; andShow: [:a | 
		a mondrian 
			painting: [ :view | self model viewCommitGraph: view selectedCommit: nil selectedSuccessor: nil ] ].
! !

!RGCommitGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/9/2011 13:34'!
onCommits

	browser transmit
		to: #commits;
		andShow: [:a |
			a list
			title: 'Commits';
			display: [ :each| self model commitNodes ];
			format: [ :each| each name ]
		].! !

!RGCommitGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/22/2011 16:29'!
onPackages

	browser transmit
		to: #packages;
		from: #commits;
		andShow: [:a |
			a list
			title: 'Packages';
			display: [ :each| self sortByName: each packages asOrderedCollection ];
			format:[ :each| each name ]
		].! !

!RGCommitGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/9/2011 10:51'!
onSuccessors

	browser transmit
		to: #successors;
		from: #commits;
		andShow: [:a |
			a list
			title: 'Successors';
			display: [ :each| each successors ];
			format:[ :each| each name ]
		].! !

!RGCommitGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/9/2011 10:38'!
titleBrowser

	^'Commit Evolution Graph'! !

RGAbstractBrowser subclass: #RGComparativeClassHistoryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGComparativeClassHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 9/9/2011 13:31'!
buildBrowser

	super buildBrowser.
	self onPackagesAndClasses.
	self onComparativeClasses! !

!RGComparativeClassHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 9/9/2011 13:31'!
layout

	browser
		column: #packagesAndClasses;
		column: #comparativeHistory span: 3.! !

!RGComparativeClassHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 9/9/2011 13:32'!
onComparativeClasses

	browser
		showOn: #comparativeHistory;
		from: #packagesAndClasses;
		using: [
			browser mondrian 
				painting: [ :view :entities |
					self model viewComparativeClassesHistoryOn: view selectedEntities: entities ].
		].! !

!RGComparativeClassHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 9/22/2011 11:53'!
onPackagesAndClasses

	browser transmit
		to: #packagesAndClasses;
		andShow: [:a |
			a tree
				title: 'Packages';
				beMultiple;
				display: [ :each| self model sortedPackages ];
				icon: [ :each | each iconByStatus ];
				format:[ :each| each name ];
				children:[ :each| 
					each isPackage 
						ifTrue: [ each visibleClasses sort: each sortByName  ] ifFalse:[ #() ] ];
				dynamicActionsOnSelection: [ :each | self defaultActions: each ].
			
			a list
				title: 'Classes';
				beMultiple;
				icon: [ :each | each iconByStatus ];
				display: [ :each| self model visibleClasses sort: self model sortByName ];
				format:[ :each| each name ];
				dynamicActionsOnSelection: [ :each | self defaultActions: each ].
		].! !

!RGComparativeClassHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/4/2011 16:11'!
titleBrowser

	^model timeStamp asString, ' (', model author, ')'! !

RGAbstractBrowser subclass: #RGEntityHistoryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGEntityHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/4/2011 15:03'!
buildBrowser

	super buildBrowser.
	self onPackages.
	self onClasses.
	self onMethods.
	self onPackageHistory.
	self onClassHistory.
	self onMethodHistory! !

!RGEntityHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/4/2011 14:56'!
layout

	browser
		row: [:c | c column: #packages; column: #classes; column: #methods ]; 
		row: [:c | c column: #packageHistory; column: #classHistory; column: #methodHistory ]! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/4/2011 14:55'!
onClassHistory

	browser
		showOn: #classHistory;
		from: #classes;
		using: [
			self onHistory
		].! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 9/16/2011 08:16'!
onClasses

	browser transmit
		to: #classes;
		from: #packages; 
		andShow: [:a |
			a list
			title: 'Classes';
			display: [ :package| package sortedDefinedClasses ];
			icon:[ :each| each iconByStatus ];			
			format:[ :each| each name ];
			when:[ :package | package sortedDefinedClasses notEmpty ];
			dynamicActionsOnSelection: [ :each | self defaultActions: each ].
			
			a list
			title: 'Extended Classes';
			display: [ :package| package sortedExtendedClasses ];
			icon:[ :each| each iconByStatus ];			
			format:[ :each| each name ];
			when:[ :package | package sortedExtendedClasses notEmpty ];
			dynamicActionsOnSelection: [ :each | self defaultActions: each ].
		].	! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/4/2011 15:22'!
onHistory

	browser mondrian 
		painting: [ :view :entity |
					entity viewVersionHistoryOn: view ].
! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/4/2011 14:55'!
onMethodHistory

	browser
		showOn: #methodHistory;
		from: #methods;
		using: [
			self onHistory
		].! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 9/16/2011 08:16'!
onMethods

	browser transmit
		to: #methods;
		from: #classes; 
		from: #packages;
		andShow: [:a |
			a list
			title: 'Methods';
			display: [ :class :pack | (class methodsInPackage: pack) sort: class sortByName  ];
			icon:[ :each| each iconByStatus ];			
			format:[ :each| each name ];
			dynamicActionsOnSelection: [ :each | self defaultActions: each ]
		].! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/4/2011 14:55'!
onPackageHistory

	browser
		showOn: #packageHistory;
		from: #packages;
		using: [
			self onHistory
		].! !

!RGEntityHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 9/16/2011 08:15'!
onPackages

	browser transmit
		to: #packages;
		andShow: [:a |
			a list
			title: 'Packages';
			icon:[ :each| each iconByStatus ];
			display: [ :version| self model sortedPackages ];
			format:[ :each| each name ];
			dynamicActionsOnSelection: [ :each | self defaultActions: each ]
		].! !

!RGEntityHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/4/2011 15:21'!
titleBrowser

	^model timeStamp asString, ' (', model author, ')'! !

RGAbstractBrowser subclass: #RGPackageGraphBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGPackageGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/22/2011 16:11'!
buildBrowser

	super buildBrowser.
	self onPackages.
	self onRepositories.
	self onPackageGraph.! !

!RGPackageGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/22/2011 16:11'!
layout

	browser
		column: [:c | c row: #packages span: 3; row: #repositories ]; 
		column: #packageGraph span: 4.! !

!RGPackageGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/22/2011 16:15'!
onPackageGraph

	browser
		showOn: #packageGraph;
		from: #packages;
		using: [
			browser mondrian 
				allowNil;
				painting: [ :view :packages | 
					self model viewPackageGraph: view selectedPackages: packages ].
		].
	
	"Need initial display"
	browser transmit to: #packageGraph; andShow: [:a | 
		a mondrian 
			painting: [ :view | self model viewPackageGraph: view selectedPackages: #() ] ].! !

!RGPackageGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/22/2011 16:25'!
onPackages

	browser transmit
		to: #packages;
		andShow: [:a |
			a list
			title: 'Packages';
			beMultiple;
			display: [ :each| self sortByName: (self model packageNames) ]
		].! !

!RGPackageGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/8/2011 17:17'!
onRepositories

	browser transmit
		to: #repositories;
		andShow: [:a |
			a list
			title: 'Repositories';
			display: [ :each| self model repositories ];
			format:[ :each| each description ]
		].! !

!RGPackageGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/22/2011 16:12'!
titleBrowser

	^'Package Evolution Graph'! !

RGAbstractBrowser subclass: #RGRepositoryHistoryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGRepositoryHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 12/1/2011 14:10'!
buildBrowser

	super buildBrowser.
	self onSnapshots.
	self onSnapshotInfo.
	self onPackages.
	self onPackageInfo.
	self onClasses.
	self onClassDefinition.
	self onMethods.
	self onSourceCode.
	self onAssociations! !

!RGRepositoryHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 9/30/2011 15:23'!
historyAction: anObject

	^GLMGenericAction new 
		title: 'View History'; 
		action: [ anObject selection viewVersionHistory ]; 
		yourself! !

!RGRepositoryHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 9/30/2011 15:04'!
implementorsAction: anObject

	^GLMGenericAction new 
		title: 'Implementors'; 
		action: [ anObject selection viewImplementorsMap ]; 
		yourself! !

!RGRepositoryHistoryBrowser methodsFor: 'initialize-release' stamp: 'VeronicaUquillas 11/17/2011 20:15'!
initialize 

	super initialize.
	self model: RGHistoryRepository current! !

!RGRepositoryHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 12/1/2011 14:17'!
layout

	browser
		column: [:c | c row: #snapshots; row: #snapshotInfo size: 23 ];
		column: [:c | c row: #packages span: 3; row: #packageInfo ]; 
		column: [:c | c row: #classes span: 2; row: #classDefinition ];
		column: [:c | c row: #methods; row: #sourceCode; row: #associations ]! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 10/21/2011 15:14'!
onAssociations
	| innerBrowser |
	
"	innerBrowser:= GLMTabulator new.
	innerBrowser row: #invocations; row: #accesses; row: #references."
	innerBrowser := GLMStacker new.
	innerBrowser aPane: #invocations; aPane: #accesses; aPane: #references; aPane: #senders; aPane: #implementors.
	innerBrowser transmit to: #invocations; fromOutside: #entity; andShow: [:a | 
			a title: 'Invocations'.
			a  list
				display: [ :mth| self sortByName: mth invocations  ];
				format:[ :each| each message ] ].
	innerBrowser transmit to: #accesses; fromOutside: #entity; andShow: [:a | 
			a title: 'Accesses'.
			a list				
				display: [ :mth| self sortByName: mth accesses ];
				format:[ :each| each labelForView ] ].
	innerBrowser transmit to: #references; fromOutside: #entity; andShow: [:a | 
			a title: 'References'.
			a list
				display: [ :mth| self sortByName: mth references ];
				format:[ :each| each targetName ] ].
	innerBrowser transmit to: #senders; fromOutside: #entity; andShow: [:a | 
			a title: 'Senders'.
			a list
				display: [ :mth| mth senders ];
				format:[ :each| each fullName ] ].
	innerBrowser transmit to: #implementors; fromOutside: #entity; andShow: [:a | 
			a title: 'Implementors'.
			a list
				display: [ :mth| self sortByName: mth implementors ];
				format:[ :each| each name ] ].
			 
	browser
		showOn: #associations;
		from: #methods;
		using: [
			browser custom: innerBrowser ]! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 10/18/2011 10:11'!
onClassDefinition

	browser
		showOn: #classDefinition;
		from: #classes;
		using: [
		browser text
			title: 'Definition';
			display: [ :cls| cls definitionSource, String crlfcrlf, cls theMetaClass definitionSource ];
			when: [ :cls| cls isMeta not and:[ cls package isExternal not ] ].

		browser text
			title: 'Comment';
			display: [ :cls| cls comment content ];
			when:[ :cls| cls isMeta not and:[ cls hasComment ] ]
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 12/1/2011 15:18'!
onClasses

	browser transmit
		to: #classes;
		from: #packages; 
		andShow: [:a |
			a list
			title: 'Classes';
			display: [ :package| package sortedDefinedClasses ];
			format:[ :each| each name ];
			textBackgroundColor:[ :each| each lightColorByStatus ];			
			when:[ :package | package sortedDefinedClasses notEmpty ];
			dynamicActionsOnSelection: [ :each | 
				(self defaultActions: each)
					add: (self historyAction: each);
					yourself ].
			
			a list
			title: 'Extended Classes';
			display: [ :package| package sortedExtendedClasses ];
			format:[ :each| each name ];
			textBackgroundColor:[ :each| each lightColorByStatus ];			
			when:[ :package | package sortedExtendedClasses notEmpty ];
			dynamicActionsOnSelection: [ :each | 
				(self defaultActions: each)
					add: (self historyAction: each);
					yourself ].
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 12/1/2011 15:17'!
onMethods

	browser transmit
		to: #methods;
		from: #classes; 
		from: #packages;
		andShow: [:a |
			a list
			title: 'Methods';
			display: [ :class :pack | (class methodsInPackage: pack) sort: class sortByName  ];
			format:[ :each| each name ];
			textBackgroundColor:[ :each| each lightColorByStatus ];
			dynamicActionsOnSelection: [ :each | 
				(self defaultActions: each) 
					add: (self historyAction: each);
					add: (self sendersAction: each); 
					add: (self implementorsAction: each);
					yourself ]
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/3/2011 16:43'!
onPackageInfo

	browser
		transmit to: #packageInfo;
		from: #packages;
		andShow: [:a | 
			a text display: [ :each | each summary ]
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 12/1/2011 16:15'!
onPackages

	browser transmit
		to: #packages;
		from: #snapshots; 
		andShow: [:a |
			a list
			title: 'Packages';
			display: [ :version| version sortedPackages ];
			format:[ :each| each name ];
			textBackgroundColor:[ :each| each isExternal ifTrue:[ nil ] ifFalse:[ each lightColorByStatus ] ];
			dynamicActionsOnSelection: [ :each | 
				(self defaultActions: each)
					add: (self historyAction: each);
					yourself ]
		].
	
	browser transmit to: #packages 
		port: #selection; 
		from: #snapshots; 
		transformed: [ :snap | | packs |
			packs := snap sortedPackages.
			packs first isExternal ifTrue: [ packs second ] ifFalse:[ packs first ] ]! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 12/1/2011 14:13'!
onSnapshotInfo

	browser
		transmit to: #snapshotInfo;
		from: #snapshots;
		andShow: [:a | 
			a text display: [ :each | each timeStamp asString ]
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 12/1/2011 14:03'!
onSnapshots

	browser
		showOn: #snapshots;
		using: [
		browser list
			title: 'Snapshots';
			display: self model snapshots reversed;
			format:[ :each| each visibleID asString, '. ', each commitMessagesLabel ];
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) 
														add: (self viewHistoryAction: each); 
														add: (self viewComparativeClassesAction: each);
													yourself ]
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 10/5/2011 17:08'!
onSourceCode

	browser
		showOn: #sourceCode;
		from: #methods;
		using: [
		browser text
			"title: 'SourceCode';"
			display: [ :mth| mth sourceCode ];
			forSmalltalk: [ :mth| mth parent ].
		].! !

!RGRepositoryHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 9/30/2011 15:04'!
sendersAction: anObject

	^GLMGenericAction new 
		title: 'Senders'; 
		action: [ anObject selection viewSendersMap ]; 
		yourself! !

!RGRepositoryHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/3/2011 17:29'!
titleBrowser

	^self model description! !

!RGRepositoryHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 8/8/2011 13:03'!
viewComparativeClassesAction: anObject

	^GLMGenericAction new 
		title: 'View Comparative Classes'; 
		action: [ RGComparativeClassHistoryBrowser open: anObject selection ]; 
		yourself! !

!RGRepositoryHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 8/4/2011 15:16'!
viewHistoryAction: anObject

	^GLMGenericAction new 
		title: 'View History'; 
		action: [ RGEntityHistoryBrowser open: anObject selection ]; 
		yourself! !

RGAbstractBrowser subclass: #RGSnapshotBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGSnapshotBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 11/15/2011 15:38'!
buildBrowser

	super buildBrowser.
	self onPackages.
	self onPackageInfo.
	self onClasses.
	self onClassDefinition.
	self onMethods.
	self onSourceCode.
	self onAssociations! !

!RGSnapshotBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 11/15/2011 15:38'!
historyAction: anObject

	^GLMGenericAction new 
		title: 'View History'; 
		action: [ anObject selection viewVersionHistory ]; 
		yourself! !

!RGSnapshotBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 11/15/2011 15:38'!
implementorsAction: anObject

	^GLMGenericAction new 
		title: 'Implementors'; 
		action: [ anObject selection viewImplementorsMap ]; 
		yourself! !

!RGSnapshotBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 11/15/2011 15:38'!
layout

	browser
		column: [:c | c row: #packages span: 3; row: #packageInfo ]; 
		column: [:c | c row: #classes span: 2; row: #classDefinition ];
		column: [:c | c row: #methods; row: #sourceCode; row: #associations ]! !

!RGSnapshotBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/15/2011 15:38'!
onAssociations
	| innerBrowser |
	
"	innerBrowser:= GLMTabulator new.
	innerBrowser row: #invocations; row: #accesses; row: #references."
	innerBrowser := GLMStacker new.
	innerBrowser aPane: #invocations; aPane: #accesses; aPane: #references; aPane: #senders; aPane: #implementors.
	innerBrowser transmit to: #invocations; fromOutside: #entity; andShow: [:a | 
			a title: 'Invocations'.
			a  list
				display: [ :mth| self sortByName: mth invocations  ];
				format:[ :each| each message ] ].
	innerBrowser transmit to: #accesses; fromOutside: #entity; andShow: [:a | 
			a title: 'Accesses'.
			a list				
				display: [ :mth| self sortByName: mth accesses ];
				format:[ :each| each labelForView ] ].
	innerBrowser transmit to: #references; fromOutside: #entity; andShow: [:a | 
			a title: 'References'.
			a list
				display: [ :mth| self sortByName: mth references ];
				format:[ :each| each targetName ] ].
	innerBrowser transmit to: #senders; fromOutside: #entity; andShow: [:a | 
			a title: 'Senders'.
			a list
				display: [ :mth| mth senders ];
				format:[ :each| each fullName ] ].
	innerBrowser transmit to: #implementors; fromOutside: #entity; andShow: [:a | 
			a title: 'Implementors'.
			a list
				display: [ :mth| self sortByName: mth implementors ];
				format:[ :each| each name ] ].
			 
	browser
		showOn: #associations;
		from: #methods;
		using: [
			browser custom: innerBrowser ]! !

!RGSnapshotBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/15/2011 15:38'!
onClassDefinition

	browser
		showOn: #classDefinition;
		from: #classes;
		using: [
		browser text
			title: 'Definition';
			display: [ :cls| cls definitionSource, String crlfcrlf, cls theMetaClass definitionSource ];
			when: [ :cls| cls isMeta not and:[ cls package isExternal not ] ].

		browser text
			title: 'Comment';
			display: [ :cls| cls comment content ];
			when:[ :cls| cls isMeta not and:[ cls hasComment ] ]
		].! !

!RGSnapshotBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/15/2011 15:38'!
onClasses

	browser transmit
		to: #classes;
		from: #packages; 
		andShow: [:a |
			a list
			title: 'Classes';
			display: [ :package| package sortedDefinedClasses ];
			format:[ :each| each name ];
			when:[ :package | package sortedDefinedClasses notEmpty ];
			dynamicActionsOnSelection: [ :each | 
				(self defaultActions: each)
					add: (self historyAction: each);
					yourself ].
			
			a list
			title: 'Extended Classes';
			display: [ :package| package sortedExtendedClasses ];
			format:[ :each| each name ];
			when:[ :package | package sortedExtendedClasses notEmpty ];
			dynamicActionsOnSelection: [ :each | 
				(self defaultActions: each)
					add: (self historyAction: each);
					yourself ].
		].! !

!RGSnapshotBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/15/2011 15:38'!
onMethods

	browser transmit
		to: #methods;
		from: #classes; 
		from: #packages;
		andShow: [:a |
			a list
			title: 'Methods';
			display: [ :class :pack | (class methodsInPackage: pack) sort: class sortByName  ];
			format:[ :each| each name ];
			dynamicActionsOnSelection: [ :each | 
				(self defaultActions: each) 
					add: (self historyAction: each);
					add: (self sendersAction: each); 
					add: (self implementorsAction: each);
					yourself ]
		].! !

!RGSnapshotBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/15/2011 15:38'!
onPackageInfo

	browser
		transmit to: #packageInfo;
		from: #packages;
		andShow: [:a | 
			a text display: [ :each | each summary ]
		].! !

!RGSnapshotBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/15/2011 15:40'!
onPackages

	browser transmit
		to: #packages;
		andShow: [:a |
			a list
			title: 'Packages';
			display: [ :each| self model sortedPackages ];
			format:[ :each| each name ];
			dynamicActionsOnSelection: [ :each | 
				(self defaultActions: each)
					add: (self historyAction: each);
					yourself ]
		].! !

!RGSnapshotBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/15/2011 15:38'!
onSourceCode

	browser
		showOn: #sourceCode;
		from: #methods;
		using: [
		browser text
			"title: 'SourceCode';"
			display: [ :mth| mth sourceCode ];
			forSmalltalk: [ :mth| mth parent ].
		].! !

!RGSnapshotBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 11/15/2011 15:38'!
sendersAction: anObject

	^GLMGenericAction new 
		title: 'Senders'; 
		action: [ anObject selection viewSendersMap ]; 
		yourself! !

!RGSnapshotBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 11/15/2011 15:39'!
titleBrowser

	^self model name! !

!RGSnapshotBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 11/15/2011 15:38'!
viewComparativeClassesAction: anObject

	^GLMGenericAction new 
		title: 'View Comparative Classes'; 
		action: [ RGComparativeClassHistoryBrowser open: anObject selection ]; 
		yourself! !

!RGSnapshotBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 11/15/2011 15:40'!
viewHistoryAction: anObject

	^GLMGenericAction new 
		title: 'View History'; 
		action: [ RGEntityHistoryBrowser open: anObject selection ]; 
		yourself! !

RGAbstractBrowser subclass: #RGSnapshotDeltaBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGSnapshotDeltaBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 10/10/2011 15:57'!
buildBrowser

	super buildBrowser.
	self onChangesPerType.
	self onChange! !

!RGSnapshotDeltaBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 10/10/2011 16:45'!
layout

	browser
		column: #changesPerType; 
		column: #change span: 2! !

!RGSnapshotDeltaBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 10/10/2011 16:57'!
onChange

	browser
		showOn: #change;
		from: #changesPerType;
		using: [
			browser diff
				title: 'Class Definition Diff';
				display: [ :each | { each obsoleteEntity definitionSource . each substituteEntity definitionSource } ];
				when: [ :each | each hasChangedDefinitionSource ].
			browser text
				title: 'Class Definition';
				forSmalltalk:[  :each | each entity ];
				when: [ :each | each isClassChange and:[ each hasChangedDefinitionSource not ] ];
				display: [ :each | each entity definitionSource ifNil:[ '<extended class>'] ].
				
			browser diff
				title: 'Source Code Diff';
				display: [ :each | { each obsoleteEntity sourceCode . each substituteEntity sourceCode } ];
				when: [ :each | each hasChangedSourceCode ].
			browser text
				title: 'Source Code';
				forSmalltalk:[  :each | each entity parent ];
				when: [ :each | each isMethodChange and:[ each hasChangedSourceCode not ] ];
				display: [ :each | each entity sourceCode ].
		].! !

!RGSnapshotDeltaBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/26/2011 19:57'!
onChangesPerType

	browser
		showOn: #changesPerType;
		using: [
		browser tree
			title: 'Changes per Entity Type';
			display: [ :each| self model historyTypes keys sort ];
			sorted: self sortBlockByFullName;
			icon: [ :each | 
				each isSymbol 
					ifTrue: [ nil ]
					ifFalse:[ each icon ] ];
			children:[ :each| 
				each isSymbol
					ifTrue: [ self model changesByEntityType: (self model historyTypes at: each) ]
					ifFalse:[ {} ] ];
			format: [ :each| 
				each isSymbol 
					ifTrue: [ each ]
					ifFalse:[ each fullName ] ]
		].! !

!RGSnapshotDeltaBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 11/25/2011 23:29'!
titleBrowser

	^self model name! !

RGAbstractBrowser subclass: #RGSnapshotDeltaHistoryBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGSnapshotDeltaHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 11/15/2011 15:50'!
baseSnapshotAction: anObject

	^GLMGenericAction new 
		title: 'Browse Base Snapshot'; 
		action: [ anObject selection base browser ]; 
		yourself! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 12/1/2011 23:45'!
buildBrowser

	super buildBrowser.
	self deltasDependenciesMapAction.
	self onDeltas.
	self onBaseOfDelta.
	self onTargetOfDelta.
	self onBasePackage.
	self onTargetPackage.
	self onGeneralInfo.
	self onDependenciesPerDelta.
	self onChangesPerDelta.
	self onSourceCode.
	self onDependenciesPerChangeAndDelta! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 12/2/2011 12:55'!
deltasDependenciesMapAction

	browser act: [:f | RGRepositoryHistoryBrowser open ] 
		icon: RGMenuIcons enhancedListIcon 
		entitled: 'Snapshots Browser'.
	browser act: [:f | self model viewDeltasDependenciesMapWithLayout:  self model treeLayout ] 
		icon: RGMenuIcons treeLayoutIcon 
		entitled: 'Deltas Dependencies Tree Map'.
	browser act: [:f | self model viewDeltasDependenciesMapWithLayout: self model forcedLayout ] 
		icon: RGMenuIcons forceBasedLayoutIcon 
		entitled: 'Deltas Dependencies Forced Map'.		! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 11/28/2011 13:39'!
dependenciesMapAction: anObject

	^GLMGenericAction new 
		title: 'View Dependencies Map'; 
		action: [ anObject selection viewDependenciesMap ]; 
		yourself! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/28/2011 14:28'!
dependenciesMapOfChange: change inDelta: delta

	^ (delta changeDependencyOf: change)
		ifNotNil: [ :dep| dep dependenciesMap ]
		ifNil:[ Dictionary new ]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/28/2011 14:28'!
dependenciesMapOfChange: change inDelta: delta ofDelta: dependentDelta

	^ (delta changeDependencyOf: change)
		ifNotNil: [ :dep| dep dependenciesMapOfDelta: dependentDelta ]
		ifNil:[ Dictionary new ]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 12/2/2011 10:53'!
dependenciesPerChangeAndDeltaTree

		browser tree
			title: 'Delta Dependencies';
			allExpanded;
			when:[ :change :delta :depDelta| (self dependenciesMapOfChange: change inDelta: delta ofDelta: depDelta) notEmpty ];
			display:[ :change :delta :depDelta| (self dependenciesMapOfChange: change inDelta: delta ofDelta: depDelta) keys ];
			icon:[ :each | each isSymbol ifTrue:[ nil ] ifFalse:[ each change icon ] ];
			format:[ :each| each isSymbol
							ifTrue:[ each ]
							ifFalse:[ each change fullName ] ];
			children:[ :each :change :delta :depDelta| | changeDependency |
				changeDependency := delta changeDependencyOf: change.
				changeDependency childrenDependenciesOf: each andDelta: depDelta ];
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ].! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 12/1/2011 16:44'!
dependenciesPerChangeTree

		browser tree
			title: 'Method Dependencies';
			allExpanded;
			allowNil;
			when:[ :change :delta| change notNil and:[ delta notNil and:[ (self dependenciesMapOfChange: change inDelta: delta) notEmpty ] ] ];
			display:[ :change :delta| (self dependenciesMapOfChange: change inDelta: delta) keys ];
			icon:[ :each | 
				(each isRingObject and:[ each isDependency ]) ifTrue:[ each change icon ] ifFalse:[ nil ] ];
			format:[ :each| 
				each isRingObject
					ifTrue: [ each isDependency ifTrue:[ each change fullName ] ifFalse:[ each nameWithExternalLabel ] ]
					ifFalse:[ each ] ];
			whiteRectangledTags;
			tags: [ :each | 
				(each isRingObject and:[ each isDependency ]) ifTrue: [ { each delta minimalName } ] ifFalse:[ #() ] ];
			children:[ :each :change :delta| | changeDependency |
				changeDependency := delta changeDependencyOf: change.
				changeDependency childrenDependenciesOf: each ];
			dynamicActionsOnSelection: [ :each | | excludeAction actions |
				actions := self defaultActions: each.
				excludeAction := self excludeChangeDependencyAction: each.
				excludeAction ifNotNil:[ actions add: excludeAction ].
				actions ]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 11/28/2011 14:26'!
excludeChangeDependency: anObject
	
	anObject isSymbol
		ifTrue: [ 
			| delta change dependency |
			delta := ((browser paneNamed: #deltas) port: #selection) value.
			change := ((browser paneNamed: #changesOfDelta) port: #selection) value.
			dependency := delta changeDependencyOf: change.
			dependency excludeDependenciesGroupedAs: anObject ]
		ifFalse:[ anObject excludeFromChangeDependency ]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 11/25/2011 15:59'!
excludeChangeDependencyAction: anObject
	
	^ (RGChangeDependency isPossibleToUpdateMap: anObject selection) 
		ifTrue: [
			GLMGenericAction new 
				title: 'Exclude Dependency'; 
				action: [ self excludeChangeDependency: anObject selection.
						 self updatePanelsWhenUpdatingDependencies ]; 
				yourself ]
		ifFalse:[ nil ]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 12/2/2011 03:26'!
excludeDeltaRecalculatingAction: anObject
	
	^ anObject selection isExcluded
		ifTrue: [ nil ]
	       ifFalse:[
			GLMGenericAction new 
				title: 'Exclude Delta (recalculating dependencies)'; 
				action: [ self model excludeDeltaRecalculatingDependencies: anObject selection.
					     self updatePanelsWhenUpdatingDeltas ]; 
				yourself ]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 12/2/2011 03:25'!
excludeDeltaRemovingAction: anObject
	
	^ anObject selection isExcluded
		ifTrue: [ nil ]
	       ifFalse:[
			GLMGenericAction new 
				title: 'Exclude Delta (removing dependencies)'; 
				action: [ self model excludeDeltaRemovingDependencies: anObject selection.
					     self updatePanelsWhenUpdatingDeltas ]; 
				yourself ]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'accessing' stamp: 'VeronicaUquillas 11/28/2011 14:27'!
excludedDependenciesMapOfChange: change inDelta: delta

	^ (delta changeDependencyOf: change)
		ifNotNil: [ :dep| dep excludedDependenciesMap ]
		ifNil:[ Dictionary new ]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 12/1/2011 16:44'!
excludedDependenciesPerChangeTree

		browser tree
			title: 'Excluded Method Dependencies';
			allExpanded;
			allowNil;
			when:[ :change :delta| change notNil and:[ delta notNil and:[ (self excludedDependenciesMapOfChange: change inDelta: delta) notEmpty ] ] ];
			display:[ :change :delta| (self excludedDependenciesMapOfChange: change inDelta: delta) keys ];
			icon:[ :each | 
				each isRingObject ifTrue:[ each change icon ] ifFalse:[ nil ] ];
			format:[ :each| 
				each isRingObject ifTrue: [ each change fullName ] ifFalse:[ each ] ];
			whiteRectangledTags;
			tags: [ :each | 
				each isRingObject ifTrue: [ { each delta minimalName } ] ifFalse:[ #() ] ];
			children:[ :each :change :delta| | changeDependency |
				changeDependency := delta changeDependencyOf: change. 
				changeDependency childrenExcludedDependenciesOf: each ];
			dynamicActionsOnSelection: [ :each | | includeAction actions |
				actions := self defaultActions: each.
				includeAction := self includeChangeDependencyAction: each.
				includeAction ifNotNil:[ actions add: includeAction ].
				actions ]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 11/15/2011 15:44'!
historyAction: anObject

	^GLMGenericAction new 
		title: 'View History'; 
		action: [ anObject selection viewVersionHistory ]; 
		yourself! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 11/28/2011 14:27'!
includeChangeDependency: anObject
	
	anObject isSymbol
		ifTrue: [ 
			| delta change dependency |
			delta := ((browser paneNamed: #deltas) port: #selection) value.
			change := ((browser paneNamed: #changesOfDelta) port: #selection) value.
			dependency := delta changeDependencyOf: change.
			dependency includeDependenciesGroupedAs: anObject ]
		ifFalse:[ anObject includeFromChangeDependency ]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 11/25/2011 15:59'!
includeChangeDependencyAction: anObject
	
	^ (RGChangeDependency isPossibleToUpdateMap: anObject selection) 
		ifTrue: [
			GLMGenericAction new 
				title: 'Include Dependency'; 
				action: [ self includeChangeDependency: anObject selection.
						 self updatePanelsWhenUpdatingDependencies ]; 
				yourself ]
		ifFalse:[ nil ]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'initialize-release' stamp: 'VeronicaUquillas 11/23/2011 22:23'!
initialSelection

	((browser paneNamed: #deltas) port: #selection) value:  self model deltas first! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 12/1/2011 23:47'!
layout

	browser
		column: [ :c| c row: #deltas span: 4; row: [:r | r column: #baseOfDelta; column: #targetOfDelta ];  row: [:r | r column: #basePackage; column: #targetPackage ]; row: #dependenciesOfDelta span: 2; row: #generalInfo ];
		column: [ :c| c row: [:r | r column: #changesOfDelta; column: #sourceCode span: 2 ]; 
					   row: #dependenciesOfChange ] span: 2.5! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/30/2011 17:52'!
onBaseOfDelta

	browser
		showOn: #baseOfDelta;
		from: #deltas;
		using: [
		browser list
			title: 'Base Snapshot Packages';
			display: [ :each| each base packagesButExternal ];
			format:[ :each| each versionName ];
			when:[ :each| each base isNilHistory not ];
			dynamicActionsOnSelection: [ :each | 
				(self defaultActions: each) ].
		].
	
	browser transmit to: #baseOfDelta 
		port: #selection; 
		from: #deltas; 
		transformed: [ :delta | 
			| packages |
			delta base isNilHistory 
				ifTrue: [ packages := #() ]
				ifFalse:[ packages := delta base packagesButExternal ].
			packages isEmpty ifTrue: [ nil ] ifFalse:[ packages first ] ]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/29/2011 11:32'!
onBasePackage

	browser
		showOn: #basePackage;
		from: #baseOfDelta;
		using: [
		browser text
			display: [ :each| each commitMessage ]
		].! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/25/2011 11:02'!
onChangesPerDelta

	browser
		showOn: #changesOfDelta;
		from: #deltas;
		using: [
		browser list
			title: 'Dependent Changes';
			display:[ :each| each dependentChanges ];
			sorted: self sortBlockByFullName;
			format:[ :each| each fullName ];
			icon: [ :each | each icon ];
			whiteRectangledTags;
			tags: [ :each | | tags |
				tags := OrderedCollection new.
				tags add: each entity numberOfChangesRelation.
				each isMethodChange ifTrue: [ 
					tags add: each entity numberOfSendersRelation;
						 add: each entity numberOfImplementorsRelation  ].
				tags ];
			when:[ :each| each dependentChanges notEmpty ];
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ].
		browser list
			title: 'Non-dependent Changes';
			display:[ :each| each nonDependentChanges ];
			sorted: self sortBlockByFullName;
			format:[ :each| each fullName ];
			icon: [ :each | each icon ];
			whiteRectangledTags;
			tags: [ :each | { each entity numberOfChangesRelation } ];
			when:[ :each| each nonDependentChanges notEmpty ];
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ]
		].
	browser transmit to: #changesOfDelta 
		port: #selection; 
		from: #deltas; 
		transformed: [:delta | 
			| changes |
			changes := self sortByFullName: (delta dependentChanges).
			changes isEmpty ifTrue: [ changes := self sortByFullName: (delta nonDependentChanges) ].
			changes isEmpty ifTrue: [ nil ] ifFalse:[ changes first ] ]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 12/2/2011 03:27'!
onDeltas

	browser
		showOn: #deltas;
		using: [
		browser list
			title: 'Deltas';
			display: (self model deltas);
			format:[ :each| each visibleID asString, '. ', each target commitMessagesLabel  ];
			textBackgroundColor:[ :each| each lightColorByNeededDeltas ];
			dynamicActionsOnSelection: [ :each | | myActions |
				myActions := 
				(self defaultActions: each) 
					add: (self targetSnapshotAction: each); 
					add: (self baseSnapshotAction: each); 
					add: (self historyAction: each);
					add: (self dependenciesMapAction: each);
				yourself.
				(self excludeDeltaRemovingAction: each) ifNotNil:[ :act|  myActions add: act ].
				(self excludeDeltaRecalculatingAction: each) ifNotNil:[ :act|  myActions add: act ].
				myActions  ] ]	! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/26/2011 21:56'!
onDependenciesPerChangeAndDelta

	browser
		showOn: #dependenciesOfChange;
		from: #changesOfDelta;
		from: #deltas;
		from: #dependenciesOfDelta;
		using: [
			self dependenciesPerChangeTree.
			self dependenciesPerChangeAndDeltaTree.
			self excludedDependenciesPerChangeTree.
		]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 12/2/2011 11:27'!
onDependenciesPerDelta

	browser
		showOn: #dependenciesOfDelta;
		from: #deltas;
		using: [
		browser list
			title: 'Needed deltas';
			display:[ :delta| self model sortDeltas: delta traversedOutgoingNeededDeltas ];
			format:[ :each| each name ];
			when:[ :each| each traversedOutgoingNeededDeltas notEmpty ];
			textBackgroundColor:[ :each| each lightColorByNeededDeltas ];
			allowDeselection;
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ].
		browser list
			title: 'Potential deltas';
			display:[ :delta| self model sortDeltas: delta traversedOutgoingPotentialDeltas ];
			format:[ :each| each name ];
			when:[ :each| each traversedOutgoingPotentialDeltas notEmpty ];
			textBackgroundColor:[ :each| each lightColorByNeededDeltas ];
			allowDeselection;
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ].
		browser list
			title: 'Deltas needing me';
			display:[ :delta| self model sortDeltas: delta traversedIncomingNeededDeltas ];
			format:[ :each| each name ];
			when:[ :each| each traversedIncomingNeededDeltas notEmpty ];
			textBackgroundColor:[ :each| each lightColorByNeededDeltas ];
			allowDeselection;
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ].
		browser list
			title: 'External needed classes';
			display:[ :delta| delta externalNeededClasses ];
			sorted: self sortBlockByName;
			format:[ :each| each ];
			when:[ :each| each externalNeededClasses notEmpty ];
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ].
		].! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 12/1/2011 23:46'!
onGeneralInfo

	browser
		showOn: #generalInfo;
		using: [
		browser list
			display: [ :each| RGColor deltaColorsAndMeanings ];
			format:[ :each| each value ];
			textBackgroundColor:[ :each| each key ]
		].! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/23/2011 17:56'!
onSourceCode

	browser
		transmit to: #sourceCode;
		from: #changesOfDelta;
		andShow: [ :a|
			a smalltalkCode 
				title: 'Source Code';
				when: [ :each| each isMethodChange and:[ each isModification not ] ];
				display: [ :each| each entity sourceCode ];
				smalltalkClass: [ :each| each entity parent ].
				
			a smalltalkCode 
				title: 'Definition Code';
				when: [ :each| each isClassChange and:[ each isModification not ] ];
				display: [ :each| each entity definitionSource ];
				smalltalkClass: [ :each| each entity ].
					
			a diff
				title: 'Source Code Diff';
				display: [ :each | { each obsoleteEntity sourceCode . each entity sourceCode } ];
				when:[ :each | each isMethodChange and:[ each isModification  ] ].
			
			a diff
				title: 'Definition Code Diff';
				display: [ :each | { each obsoleteEntity definitionSource . each entity definitionSource } ];
				when:[ :each | each isClassChange and:[ each isModification  ] ].
				
			a list
				title: 'Categories';
				when:[ :each| each isPackageChange and:[ each isModification not or:[ each entity wasModifiedByClasses ] ] ];
				display:[ :each| each entity categories sort ].
			
			a diff
				title: 'Categories Diff';
				display: [ :each | { each obsoleteEntity categoriesAsText . each entity categoriesAsText } ];
				when:[ :each | each isPackageChange and:[ each isModification and:[ each entity wasModifiedByDefinition ] ] ].
			]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/29/2011 11:38'!
onTargetOfDelta

	browser
		showOn: #targetOfDelta;
		from: #deltas;
		using: [
		browser list
			title: 'Target Snapshot Packages';
			display: [ :each| each target packagesButExternal ];
			format:[ :each| each versionName ];
			dynamicActionsOnSelection: [ :each | (self defaultActions: each) ]
		].
	
	browser transmit to: #targetOfDelta 
		port: #selection; 
		from: #deltas; 
		transformed: [ :delta | 
			| packages |
			packages := delta target packagesButExternal.
			packages isEmpty ifTrue: [ nil ] ifFalse:[ packages first ] ]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 11/29/2011 11:32'!
onTargetPackage

	browser
		showOn: #targetPackage;
		from: #targetOfDelta;
		using: [
		browser text
			display: [ :each| each commitMessage ]
		].! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'private' stamp: 'VeronicaUquillas 11/26/2011 23:06'!
rejectFalsePositives: aCollection

	^ aCollection reject:[ :ref | ref isFalsePositive ]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'private' stamp: 'VeronicaUquillas 11/26/2011 23:08'!
rejectFalsePositivesDep: aCollection

	^ aCollection reject:[ :ref | ref isDependency and:[ ref isFalsePositive ] ]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'sorting' stamp: 'VeronicaUquillas 11/25/2011 14:45'!
sortSubDependenciesByFullName: subDependencies

	^ subDependencies sort: [:e1 :e2 | e1 change fullName <= e2 change fullName ]! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 11/15/2011 15:50'!
targetSnapshotAction: anObject

	^GLMGenericAction new 
		title: 'Browse Target Snapshot'; 
		action: [ anObject selection target browser ]; 
		yourself! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 10/19/2011 10:35'!
titleBrowser

	^ 'Snapshot Delta History'! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 12/2/2011 03:42'!
updatePanelsWhenUpdatingDeltas

	(browser paneNamed: #deltas) update.
	(browser paneNamed: #changesOfDelta) update.
	(browser paneNamed: #dependenciesOfChange) update.
	(browser paneNamed: #dependenciesOfDelta) update! !

!RGSnapshotDeltaHistoryBrowser methodsFor: 'actions' stamp: 'VeronicaUquillas 12/2/2011 02:00'!
updatePanelsWhenUpdatingDependencies

	(browser paneNamed: #dependenciesOfChange) update.
	(browser paneNamed: #dependenciesOfDelta) update	! !

RGAbstractBrowser subclass: #RGSnapshotGraphBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ring-History-Browsers'!

!RGSnapshotGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/9/2011 16:51'!
buildBrowser

	super buildBrowser.
	self onSnapshots.
	self onPackages.
	self onSuccessors.
	self onSnapshotGraph ! !

!RGSnapshotGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/9/2011 16:49'!
layout

	browser
		column: [:c | c row: #snapshots span: 3; row: #packages; row: #successors ]; 
		column: #snapshotGraph span: 4.! !

!RGSnapshotGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/22/2011 16:31'!
onPackages

	browser transmit
		to: #packages;
		from: #snapshots;
		andShow: [:a |
			a list
			title: 'Packages';
			display: [ :each| self sortByName: each packages asOrderedCollection ];
			format:[ :each| each name ]
		].! !

!RGSnapshotGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/9/2011 16:50'!
onSnapshotGraph

	browser
		showOn: #snapshotGraph;
		from: #snapshots;
		from: #successors;
		using: [
			browser mondrian 
				allowNil;
				painting: [ :view :snapshot :successor |
					self model viewSnapshotGraph: view selectedSnapshot: snapshot selectedSuccessor: successor]
		].
	
	"Need initial display"
	browser transmit to: #snapshotGraph; andShow: [:a | 
		a mondrian 
			painting: [ :view | self model viewSnapshotGraph: view selectedSnapshot: nil selectedSuccessor: nil ] ].
! !

!RGSnapshotGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/9/2011 16:50'!
onSnapshots

	browser transmit
		to: #snapshots;
		andShow: [:a |
			a list
			title: 'Snapshots';
			display: [ :each| self model snapshots ];
			format: [ :each| each name ]
		].! !

!RGSnapshotGraphBrowser methodsFor: 'panels' stamp: 'VeronicaUquillas 8/9/2011 16:56'!
onSuccessors

	browser transmit
		to: #successors;
		from: #snapshots;
		andShow: [:a |
			a list
			title: 'Successors';
			display: [ :each| each successors ];
			format:[ :each| each name ]
		].! !

!RGSnapshotGraphBrowser methodsFor: 'building' stamp: 'VeronicaUquillas 8/9/2011 16:51'!
titleBrowser

	^'Snapshot Evolution Graph'! !

!MOViewRenderer methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 10/3/2011 14:53'!
edgeFrom: aFromBlock to: aToBlock using: aShape
	
	^self edges: self domain from: aFromBlock to: aToBlock using: aShape! !

!MOViewRenderer methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 9/29/2011 12:49'!
edgeFrom: aFromBlock toAll: aToBlock
	
	^self edges: self domain from: aFromBlock toAll: aToBlock! !

!RGAddedChange methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/28/2011 15:47'!
color

	^ RGColor green4! !

!RGAddedChange methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 11/29/2011 09:43'!
viewSourceCodeOn: view

	entity viewSourceCodeOn: view diffTo: nil ! !

!RGSnapshotGraph methodsFor: '*Ring-History-Browsers' stamp: 'VeronicaUquillas 8/22/2011 17:55'!
viewSnapshotGraph: view selectedSnapshot: selectedSnapshot selectedSuccessor: selectedSuccessor

	view nodeShape
		borderColor: [ :each| each borderColorNode: (selectedSnapshot ifNil:[ #() ] ifNotNil:[ :s| s successors ]) ];
		fillColor:[ :each| each colorNode: selectedSnapshot successor: selectedSuccessor ].
	view nodes: self snapshots forEach:[ :snap|
		view nodeShape
			borderColor:[ :each| each borderColorNode ];
			fillColor:[ :each| each colorNode ].
		view nodes: snap commit packages.
		view nodeShape
			borderStyle:[ :each| BorderStyle dashed ];
			borderColor:[ :each| each borderColorNode ];
			fillColor:[ :each| each colorNode ]. 
		view nodes: snap nonCommitPackages.
		view flowLayout maxWidth: 40 ].
	view edges: self snapshots from: [ :n| n ] toAll:[ :n | n successors ].
	view horizontalDominanceTreeLayout 
		verticalGap: 8! !
